<template src="./template.html"></template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import axios from "axios";
import { api } from "~/common/constaint";
import * as _ from "lodash";
import { redirectPage } from "~/utils/apiHanlers";
//@ts-ignore
import language from "~/locales/language-product.json";
import { findIndex } from "lodash";
@Component({
  components: {},
})
export default class HeaderComponent extends Vue {
  search = "";
  drawerProduct = false;
  drawer = false;
  drawerMenuPolicy = false;

  loadingTable = false;
  loading = false;

  listProduct = [];

  get listCart() {
    return this.$store.state.cart?.listCart || [];
  }

  listPolicy = [
    { name: "Refund policy", link: "/refund-policy" },
    { name: "Privacy policy", link: "/privacy-policy" },
    { name: "Shipping policy", link: "/shipping-policy" },
    { name: "Terms of service", link: "/terms-of-service" },
    { name: "Return Policy", link: "/return-policy" },
  ];

  async onDecrease(variant: any, i: number) {
    this.loading = true;
    //@ts-ignore
    const cart = JSON.parse(localStorage.getItem("cart")) || [];
    if (variant.quantity > 1) {
      variant -= 1;
      cart[i] = variant;
    }
    this.$store.commit("cart/setListCart", cart);
    localStorage.setItem("cart", cart);
    this.loading = false;
  }

  async onIncrease(variant: any, i: number) {
    this.loading = true;
    //@ts-ignore
    const cart = JSON.parse(localStorage.getItem("cart")) || [];
    if (variant.quantity > 1) {
      variant += 1;
      cart[i] = variant;
    }
    this.$store.commit("cart/setListCart", cart);
    localStorage.setItem("cart", cart);
    this.loading = false;
  }

  async onDelete(i: number) {
    //@ts-ignore
    const cart = JSON.parse(localStorage.getItem("cart")) || [];
    cart.splice(i, 1);
    this.$store.commit("cart/setListCart", cart);
    localStorage.setItem("cart", cart);
  }

  convertImg(product: any) {
    if (product.imageId.imageUrl) {
      return `${api}/${product.imageId.imageUrl}`;
    }
    return "";
  }

  calcSalePrice(product: any) {
    return product.price;
  }

  calcPrice(product: any) {
    return product.comparePrice;
  }

  onGetListBySearch() {
    if (this.search) {
      redirectPage(`/search?q=${this.search}`);
    }
  }

  get totalCart() {
    return this.$store.state.cart.listCart.length || 0;
  }

  get totalPrice() {
    let price = 0;
    const cart = this.$store.state.cart.cart;
    if (cart.listSelectedProduct && cart.listSelectedProduct.length) {
      for (let product of this.cart.listSelectedProduct) {
        price += product.productId.salePrice * product.quantity;
      }
    }
    if (cart.listSelectedCombo && cart.listSelectedCombo.length) {
      for (let combo of this.cart.listSelectedCombo) {
        price += combo.comboId.price * combo.quantity;
      }
    }
    return price.toFixed(2);
  }

  get cart() {
    return this.$store.state.cart.cart;
  }

  get convertImage() {
    if (this.setting && this.setting.logo) {
      return `${api}/${this.setting.logo}`;
    }
    return "";
  }
  get setting() {
    return this.$store.state.setting.setting;
  }
  timer = "";
  onCalcTimer() {
    const that = this;
    const promotion = that.$store.state.promotion.promotion;
    if (promotion.status === 1) {
      var x = setInterval(function () {
        // Get today's date and time
        var now = new Date().getTime();
        // Find the distance between now and the count down date
        var distance = promotion.to * 1000 - now;
        // Time calculations for days, hours, minutes and seconds
        var days = Math.floor(distance / (1000 * 60 * 60 * 24));
        var hours = Math.floor(
          (distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60)
        );
        var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
        var seconds = Math.floor((distance % (1000 * 60)) / 1000);
        that.timer = `${
          days
            ? days < 10
              ? `0${days} ${days > 1 ? `days` : "day"} `
              : `${days} ${days > 1 ? `days` : "day"} `
            : ""
        }${hours ? (hours < 10 ? `0${hours}:` : `${hours}:`) : "00:"}${
          minutes ? (minutes < 10 ? `0${minutes}:` : `${minutes}:`) : "00:"
        }${seconds ? (seconds < 10 ? `0${seconds}` : `${seconds}`) : ""}`;
        if (distance < 0) {
          clearInterval(x);
          that.timer = "";
        }
      }, 1000);
    }
  }

  get $language() {
    if (this.$store.state.product.language.welcomeTo) {
      return this.$store.state.product.language;
    }
    return language.EN;
  }
}
</script>

<style src="./style.css"></style>
<style lang="scss" scoped>
.back-btn {
  position: absolute;
  top: 50%;
  left: 0;
  transform: translateY(-50%);
}

.image-logo {
  width: 175px;
  height: 60px;
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);

  img {
    width: 100%;
    height: 100%;
    object-fit: scale-down;
  }
}
</style>
